diff --git a/fs/Kconfig b/fs/Kconfig
index 860ca257c681..a069d3b82920 100644
--- a/fs/Kconfig
+++ b/fs/Kconfig
@@ -372,7 +372,7 @@ config NFS_V4_2_SSC_HELPER
 source "net/sunrpc/Kconfig"
 source "fs/ceph/Kconfig"
 
-source "fs/cifs/Kconfig"
+source "fs/smbfs/Kconfig"
 source "fs/ksmbd/Kconfig"
 
 config SMBFS_COMMON
diff --git a/fs/Makefile b/fs/Makefile
index a07039e124ce..dd9ecb89c32a 100644
--- a/fs/Makefile
+++ b/fs/Makefile
@@ -99,7 +99,7 @@ obj-$(CONFIG_NLS)		+= nls/
 obj-y				+= unicode/
 obj-$(CONFIG_SYSV_FS)		+= sysv/
 obj-$(CONFIG_SMBFS_COMMON)	+= smbfs_common/
-obj-$(CONFIG_SMBFS)		+= cifs/
+obj-$(CONFIG_SMBFS)		+= smbfs/
 obj-$(CONFIG_SMB_SERVER)	+= ksmbd/
 obj-$(CONFIG_HPFS_FS)		+= hpfs/
 obj-$(CONFIG_NTFS_FS)		+= ntfs/
diff --git a/fs/cifs/Kconfig b/fs/smbfs/Kconfig
similarity index 100%
rename from fs/cifs/Kconfig
rename to fs/smbfs/Kconfig
diff --git a/fs/cifs/Makefile b/fs/smbfs/Makefile
similarity index 100%
rename from fs/cifs/Makefile
rename to fs/smbfs/Makefile
diff --git a/fs/cifs/asn1.c b/fs/smbfs/asn1.c
similarity index 100%
rename from fs/cifs/asn1.c
rename to fs/smbfs/asn1.c
diff --git a/fs/cifs/cifs_debug.c b/fs/smbfs/cifs_debug.c
similarity index 100%
rename from fs/cifs/cifs_debug.c
rename to fs/smbfs/cifs_debug.c
diff --git a/fs/cifs/cifs_debug.h b/fs/smbfs/cifs_debug.h
similarity index 100%
rename from fs/cifs/cifs_debug.h
rename to fs/smbfs/cifs_debug.h
diff --git a/fs/cifs/cifs_dfs_ref.c b/fs/smbfs/cifs_dfs_ref.c
similarity index 100%
rename from fs/cifs/cifs_dfs_ref.c
rename to fs/smbfs/cifs_dfs_ref.c
diff --git a/fs/cifs/cifs_fs_sb.h b/fs/smbfs/cifs_fs_sb.h
similarity index 100%
rename from fs/cifs/cifs_fs_sb.h
rename to fs/smbfs/cifs_fs_sb.h
diff --git a/fs/cifs/cifs_ioctl.h b/fs/smbfs/cifs_ioctl.h
similarity index 100%
rename from fs/cifs/cifs_ioctl.h
rename to fs/smbfs/cifs_ioctl.h
diff --git a/fs/cifs/cifs_spnego.c b/fs/smbfs/cifs_spnego.c
similarity index 100%
rename from fs/cifs/cifs_spnego.c
rename to fs/smbfs/cifs_spnego.c
diff --git a/fs/cifs/cifs_spnego.h b/fs/smbfs/cifs_spnego.h
similarity index 100%
rename from fs/cifs/cifs_spnego.h
rename to fs/smbfs/cifs_spnego.h
diff --git a/fs/cifs/cifs_spnego_negtokeninit.asn1 b/fs/smbfs/cifs_spnego_negtokeninit.asn1
similarity index 100%
rename from fs/cifs/cifs_spnego_negtokeninit.asn1
rename to fs/smbfs/cifs_spnego_negtokeninit.asn1
diff --git a/fs/cifs/cifs_swn.c b/fs/smbfs/cifs_swn.c
similarity index 100%
rename from fs/cifs/cifs_swn.c
rename to fs/smbfs/cifs_swn.c
diff --git a/fs/cifs/cifs_swn.h b/fs/smbfs/cifs_swn.h
similarity index 100%
rename from fs/cifs/cifs_swn.h
rename to fs/smbfs/cifs_swn.h
diff --git a/fs/cifs/cifs_unicode.c b/fs/smbfs/cifs_unicode.c
similarity index 100%
rename from fs/cifs/cifs_unicode.c
rename to fs/smbfs/cifs_unicode.c
diff --git a/fs/cifs/cifs_unicode.h b/fs/smbfs/cifs_unicode.h
similarity index 100%
rename from fs/cifs/cifs_unicode.h
rename to fs/smbfs/cifs_unicode.h
diff --git a/fs/cifs/cifs_uniupr.h b/fs/smbfs/cifs_uniupr.h
similarity index 100%
rename from fs/cifs/cifs_uniupr.h
rename to fs/smbfs/cifs_uniupr.h
diff --git a/fs/cifs/cifsacl.c b/fs/smbfs/cifsacl.c
similarity index 100%
rename from fs/cifs/cifsacl.c
rename to fs/smbfs/cifsacl.c
diff --git a/fs/cifs/cifsacl.h b/fs/smbfs/cifsacl.h
similarity index 100%
rename from fs/cifs/cifsacl.h
rename to fs/smbfs/cifsacl.h
diff --git a/fs/cifs/cifsencrypt.c b/fs/smbfs/cifsencrypt.c
similarity index 100%
rename from fs/cifs/cifsencrypt.c
rename to fs/smbfs/cifsencrypt.c
diff --git a/fs/cifs/cifsglob.h b/fs/smbfs/cifsglob.h
similarity index 100%
rename from fs/cifs/cifsglob.h
rename to fs/smbfs/cifsglob.h
diff --git a/fs/cifs/cifspdu.h b/fs/smbfs/cifspdu.h
similarity index 100%
rename from fs/cifs/cifspdu.h
rename to fs/smbfs/cifspdu.h
diff --git a/fs/cifs/cifsproto.h b/fs/smbfs/cifsproto.h
similarity index 100%
rename from fs/cifs/cifsproto.h
rename to fs/smbfs/cifsproto.h
diff --git a/fs/cifs/cifsroot.c b/fs/smbfs/cifsroot.c
similarity index 100%
rename from fs/cifs/cifsroot.c
rename to fs/smbfs/cifsroot.c
diff --git a/fs/cifs/cifssmb.c b/fs/smbfs/cifssmb.c
similarity index 100%
rename from fs/cifs/cifssmb.c
rename to fs/smbfs/cifssmb.c
diff --git a/fs/cifs/connect.c b/fs/smbfs/connect.c
similarity index 100%
rename from fs/cifs/connect.c
rename to fs/smbfs/connect.c
diff --git a/fs/cifs/core.c b/fs/smbfs/core.c
similarity index 100%
rename from fs/cifs/core.c
rename to fs/smbfs/core.c
diff --git a/fs/cifs/dfs_cache.c b/fs/smbfs/dfs_cache.c
similarity index 100%
rename from fs/cifs/dfs_cache.c
rename to fs/smbfs/dfs_cache.c
diff --git a/fs/cifs/dfs_cache.h b/fs/smbfs/dfs_cache.h
similarity index 100%
rename from fs/cifs/dfs_cache.h
rename to fs/smbfs/dfs_cache.h
diff --git a/fs/cifs/dir.c b/fs/smbfs/dir.c
similarity index 100%
rename from fs/cifs/dir.c
rename to fs/smbfs/dir.c
diff --git a/fs/cifs/dns_resolve.c b/fs/smbfs/dns_resolve.c
similarity index 100%
rename from fs/cifs/dns_resolve.c
rename to fs/smbfs/dns_resolve.c
diff --git a/fs/cifs/dns_resolve.h b/fs/smbfs/dns_resolve.h
similarity index 100%
rename from fs/cifs/dns_resolve.h
rename to fs/smbfs/dns_resolve.h
diff --git a/fs/cifs/export.c b/fs/smbfs/export.c
similarity index 100%
rename from fs/cifs/export.c
rename to fs/smbfs/export.c
diff --git a/fs/cifs/file.c b/fs/smbfs/file.c
similarity index 100%
rename from fs/cifs/file.c
rename to fs/smbfs/file.c
diff --git a/fs/cifs/fs_context.c b/fs/smbfs/fs_context.c
similarity index 100%
rename from fs/cifs/fs_context.c
rename to fs/smbfs/fs_context.c
diff --git a/fs/cifs/fs_context.h b/fs/smbfs/fs_context.h
similarity index 100%
rename from fs/cifs/fs_context.h
rename to fs/smbfs/fs_context.h
diff --git a/fs/cifs/fscache.c b/fs/smbfs/fscache.c
similarity index 100%
rename from fs/cifs/fscache.c
rename to fs/smbfs/fscache.c
diff --git a/fs/cifs/fscache.h b/fs/smbfs/fscache.h
similarity index 100%
rename from fs/cifs/fscache.h
rename to fs/smbfs/fscache.h
diff --git a/fs/cifs/inode.c b/fs/smbfs/inode.c
similarity index 100%
rename from fs/cifs/inode.c
rename to fs/smbfs/inode.c
diff --git a/fs/cifs/ioctl.c b/fs/smbfs/ioctl.c
similarity index 100%
rename from fs/cifs/ioctl.c
rename to fs/smbfs/ioctl.c
diff --git a/fs/cifs/link.c b/fs/smbfs/link.c
similarity index 100%
rename from fs/cifs/link.c
rename to fs/smbfs/link.c
diff --git a/fs/cifs/misc.c b/fs/smbfs/misc.c
similarity index 100%
rename from fs/cifs/misc.c
rename to fs/smbfs/misc.c
diff --git a/fs/cifs/netlink.c b/fs/smbfs/netlink.c
similarity index 100%
rename from fs/cifs/netlink.c
rename to fs/smbfs/netlink.c
diff --git a/fs/cifs/netlink.h b/fs/smbfs/netlink.h
similarity index 100%
rename from fs/cifs/netlink.h
rename to fs/smbfs/netlink.h
diff --git a/fs/cifs/netmisc.c b/fs/smbfs/netmisc.c
similarity index 100%
rename from fs/cifs/netmisc.c
rename to fs/smbfs/netmisc.c
diff --git a/fs/cifs/nterr.c b/fs/smbfs/nterr.c
similarity index 100%
rename from fs/cifs/nterr.c
rename to fs/smbfs/nterr.c
diff --git a/fs/cifs/nterr.h b/fs/smbfs/nterr.h
similarity index 100%
rename from fs/cifs/nterr.h
rename to fs/smbfs/nterr.h
diff --git a/fs/cifs/ntlmssp.h b/fs/smbfs/ntlmssp.h
similarity index 100%
rename from fs/cifs/ntlmssp.h
rename to fs/smbfs/ntlmssp.h
diff --git a/fs/cifs/readdir.c b/fs/smbfs/readdir.c
similarity index 100%
rename from fs/cifs/readdir.c
rename to fs/smbfs/readdir.c
diff --git a/fs/cifs/rfc1002pdu.h b/fs/smbfs/rfc1002pdu.h
similarity index 100%
rename from fs/cifs/rfc1002pdu.h
rename to fs/smbfs/rfc1002pdu.h
diff --git a/fs/cifs/sess.c b/fs/smbfs/sess.c
similarity index 100%
rename from fs/cifs/sess.c
rename to fs/smbfs/sess.c
diff --git a/fs/cifs/smb1ops.c b/fs/smbfs/smb1ops.c
similarity index 100%
rename from fs/cifs/smb1ops.c
rename to fs/smbfs/smb1ops.c
diff --git a/fs/cifs/smb2file.c b/fs/smbfs/smb2file.c
similarity index 100%
rename from fs/cifs/smb2file.c
rename to fs/smbfs/smb2file.c
diff --git a/fs/cifs/smb2glob.h b/fs/smbfs/smb2glob.h
similarity index 100%
rename from fs/cifs/smb2glob.h
rename to fs/smbfs/smb2glob.h
diff --git a/fs/cifs/smb2inode.c b/fs/smbfs/smb2inode.c
similarity index 100%
rename from fs/cifs/smb2inode.c
rename to fs/smbfs/smb2inode.c
diff --git a/fs/cifs/smb2maperror.c b/fs/smbfs/smb2maperror.c
similarity index 100%
rename from fs/cifs/smb2maperror.c
rename to fs/smbfs/smb2maperror.c
diff --git a/fs/cifs/smb2misc.c b/fs/smbfs/smb2misc.c
similarity index 100%
rename from fs/cifs/smb2misc.c
rename to fs/smbfs/smb2misc.c
diff --git a/fs/cifs/smb2ops.c b/fs/smbfs/smb2ops.c
similarity index 100%
rename from fs/cifs/smb2ops.c
rename to fs/smbfs/smb2ops.c
diff --git a/fs/cifs/smb2pdu.c b/fs/smbfs/smb2pdu.c
similarity index 100%
rename from fs/cifs/smb2pdu.c
rename to fs/smbfs/smb2pdu.c
diff --git a/fs/cifs/smb2pdu.h b/fs/smbfs/smb2pdu.h
similarity index 100%
rename from fs/cifs/smb2pdu.h
rename to fs/smbfs/smb2pdu.h
diff --git a/fs/cifs/smb2proto.h b/fs/smbfs/smb2proto.h
similarity index 100%
rename from fs/cifs/smb2proto.h
rename to fs/smbfs/smb2proto.h
diff --git a/fs/cifs/smb2status.h b/fs/smbfs/smb2status.h
similarity index 100%
rename from fs/cifs/smb2status.h
rename to fs/smbfs/smb2status.h
diff --git a/fs/cifs/smb2transport.c b/fs/smbfs/smb2transport.c
similarity index 100%
rename from fs/cifs/smb2transport.c
rename to fs/smbfs/smb2transport.c
diff --git a/fs/cifs/smbdirect.c b/fs/smbfs/smbdirect.c
similarity index 100%
rename from fs/cifs/smbdirect.c
rename to fs/smbfs/smbdirect.c
diff --git a/fs/cifs/smbdirect.h b/fs/smbfs/smbdirect.h
similarity index 100%
rename from fs/cifs/smbdirect.h
rename to fs/smbfs/smbdirect.h
diff --git a/fs/cifs/smbencrypt.c b/fs/smbfs/smbencrypt.c
similarity index 100%
rename from fs/cifs/smbencrypt.c
rename to fs/smbfs/smbencrypt.c
diff --git a/fs/cifs/smberr.h b/fs/smbfs/smberr.h
similarity index 100%
rename from fs/cifs/smberr.h
rename to fs/smbfs/smberr.h
diff --git a/fs/cifs/smbfs.h b/fs/smbfs/smbfs.h
similarity index 100%
rename from fs/cifs/smbfs.h
rename to fs/smbfs/smbfs.h
diff --git a/fs/cifs/trace.c b/fs/smbfs/trace.c
similarity index 100%
rename from fs/cifs/trace.c
rename to fs/smbfs/trace.c
diff --git a/fs/cifs/trace.h b/fs/smbfs/trace.h
similarity index 100%
rename from fs/cifs/trace.h
rename to fs/smbfs/trace.h
diff --git a/fs/cifs/transport.c b/fs/smbfs/transport.c
similarity index 100%
rename from fs/cifs/transport.c
rename to fs/smbfs/transport.c
diff --git a/fs/cifs/unc.c b/fs/smbfs/unc.c
similarity index 100%
rename from fs/cifs/unc.c
rename to fs/smbfs/unc.c
diff --git a/fs/cifs/winucase.c b/fs/smbfs/winucase.c
similarity index 100%
rename from fs/cifs/winucase.c
rename to fs/smbfs/winucase.c
diff --git a/fs/cifs/xattr.c b/fs/smbfs/xattr.c
similarity index 100%
rename from fs/cifs/xattr.c
rename to fs/smbfs/xattr.c